unit fen;

interface

uses param, util, attack, sysutils, hash;

procedure readfen(fen:string);

implementation

procedure readfen(fen:string);
var
  pos,sp:string;
  x,y,i:byte;
begin
  for i:=0 to 255 do
    board[i]:=0;
  tree[0].matw:=0; tree[0].matb:=0;
  tree[0].wking:=0; tree[0].bking:=0;
  tree[0].wqueen:=255; tree[0].bqueen:=255;
  pos:=substr(fen,' ');
  for x:=7 downto 0 do
  begin
    y:=0;
    sp:=substr(pos,'/');
    for i:=1 to length(sp) do
    begin
      case sp[i] of
      '1'..'9': inc(y,ord(sp[i])-ord('1'));
      'k':      board[(x shl 4) or y]:=king or black;
      'K':      board[(x shl 4) or y]:=king or white;
      'q':      board[(x shl 4) or y]:=queen or black;
      'Q':      board[(x shl 4) or y]:=queen or white;
      'r':      board[(x shl 4) or y]:=rook or black;
      'R':      board[(x shl 4) or y]:=rook or white;
      'b':      board[(x shl 4) or y]:=bishop or black;
      'B':      board[(x shl 4) or y]:=bishop or white;
      'n':      board[(x shl 4) or y]:=knight or black;
      'N':      board[(x shl 4) or y]:=knight or white;
      'p':      board[(x shl 4) or y]:=pawn or black;
      'P':      board[(x shl 4) or y]:=pawn or white;
      end;
      if (board[(x shl 4) or y] and 7)<>1 then
      begin
        if (board[(x shl 4) or y] and 7)=2 then
        begin
          if (board[(x shl 4) or y] and 128)<>0 then tree[0].bqueen:=(x shl 4) or y
          else tree[0].wqueen:=(x shl 4) or y;
        end;
        if (board[(x shl 4) or y] and 128)<>0 then inc(tree[0].matb,prices[board[(x shl 4) or y] and 7])
        else inc(tree[0].matw,prices[board[(x shl 4) or y] and 7]);
      end else
      begin
        if (board[(x shl 4) or y] and 128)<>0 then tree[0].bking:=(x shl 4) or y
        else tree[0].wking:=(x shl 4) or y;
      end;
      inc(y);
    end;
  end;
  pos:=substr(fen,' ');
  if pos='w' then tree[0].tomove:=0;
  if pos='b' then tree[0].tomove:=1;
  pos:=substr(fen,' ');
  tree[0].castles:=0;
  for i:=1 to length(pos) do
    case pos[i] of
    'k': tree[0].castles:=tree[0].castles or blackking;
    'K': tree[0].castles:=tree[0].castles or whiteking;
    'q': tree[0].castles:=tree[0].castles or blackqueen;
    'Q': tree[0].castles:=tree[0].castles or whitequeen;
    end;
  pos:=uppercase(substr(fen,' '));
  if pos='-' then tree[0].enpass:=255
  else tree[0].enpass:=(ord(pos[1])-ord('A')) or ((ord(pos[2])-ord('1')) shl 4);
  tree[0].check:=attacked(tree[0].tomove,0,255);
  tree[0].boardkey:=GetPosHash(0);
  tree[0].pawnkey:=GetPawnHash;
  Rule50:=0;
end;

end.
