unit param;

interface

const
  ver='Uralochka v 1.1d';
  startfen='rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1';

  maxply=50;

  king=   1;
  queen=  2;
  rook=   3;
  bishop= 4;
  knight= 5;
  pawn=   6;
  white=  64;
  black=  128;

  whiteking=  1;
  whitequeen= 2;
  blackking=  4;
  blackqueen= 8;

  inf=      100000;
  cpawn=    100;
  cknight=  400;
  cbishop=  400;
  crook=    600;
  cqueen=   1200;
  cking=    inf;

  prices:array[0..6] of integer=
    (0,cking,cqueen,crook,cbishop,cknight,cpawn);

  koord:array[0..127] of string[2]=
        ('a1','b1','c1','d1','e1','f1','g1','h1','**','**','**','**','**','**','**','**',
         'a2','b2','c2','d2','e2','f2','g2','h2','**','**','**','**','**','**','**','**',
         'a3','b3','c3','d3','e3','f3','g3','h3','**','**','**','**','**','**','**','**',
         'a4','b4','c4','d4','e4','f4','g4','h4','**','**','**','**','**','**','**','**',
         'a5','b5','c5','d5','e5','f5','g5','h5','**','**','**','**','**','**','**','**',
         'a6','b6','c6','d6','e6','f6','g6','h6','**','**','**','**','**','**','**','**',
         'a7','b7','c7','d7','e7','f7','g7','h7','**','**','**','**','**','**','**','**',
         'a8','b8','c8','d8','e8','f8','g8','h8','**','**','**','**','**','**','**','**');

  figs:array[0..1,0..6] of char=
        (('.','K','Q','R','B','N','P'),
         ('.','k','q','r','b','n','p'));
type
  TRule=record
    depth:byte;
    movetime:longint;
    wtime,btime,winc,binc:longint;
    mate:byte;
    infinite:boolean;
    movestogo:byte;
    nodes:longint;
    ponder:boolean;
  end;

  TTree=record
    tomove,castles,enpass:byte;
    boardkey:int64;
    pawnkey:integer;
    matw,matb:integer;
    wking,bking:byte;
    wqueen,bqueen:byte;
    movenum,lastmove:integer;
    check:boolean;
    hmove:integer;
    hflag:byte;
    hscore:integer;
    hdepth:byte;
    hmate:boolean;
  end;

  TLine=array[0..maxply] of integer;

var

  board:array[0..255] of byte;

  tree:array[0..200] of TTree;

  moves:array[1..300*(maxply+1)] of integer;
  sortm:array[1..2,1..300*(maxply+1)] of integer;
  sortroot:array[1..2,1..300] of integer;

  rules:TRule;
  age:byte;

  rasst:array[0..127,0..127] of byte;
  vert,hor:array[0..127] of byte;

  otmena:boolean;

  ponder:boolean;

  rule50:byte;
  ProvHash:array[0..128] of int64;

  is_gg:boolean;

  nodes,NPS:longint;
  maxtime:longint;

implementation

end.
