unit think;

interface

uses param, util, sysutils, genmoves, genkills, movemake, eval, attack, sortmoves, hash;

//procedure go;
function go(p : pointer) : ptrint;
function SearchRoot(depth,ply:byte; var lin:tline):integer;
function Search(alpha,beta:integer; depth,ply:byte; null:boolean; var lin:tline):integer;
function QSearch(alpha,beta:integer; ply:byte):integer;

implementation

//procedure go;
function go(p : pointer) : ptrint; 
var tim,tim1,incr,movs:longint;
    i,j,ev:integer;
    lin,bestlin:tline;
    s:string;
begin
  result := 0;
  StartTimer;
  maxtime:=-1;
  inc(age);
  movs:=rules.movestogo;
  if movs=0 then movs:=30
  else inc(movs);
  if tree[0].tomove=0 then
  begin
    tim:=rules.wtime-300;
    incr:=rules.winc;
  end else
  begin
    tim:=rules.btime-300;
    incr:=rules.binc;
  end;
  if tim<0 then tim:=0;
  if rules.movetime<>0 then maxtime:=rules.movetime-300;
  if tim>0 then
  begin
    tim1:=((tim+incr*(movs-1))div movs)-500;
    if Rules.ponder then tim1:=trunc(1.1*tim1);
    if tim1>tim then tim1:=tim;
    if rules.movestogo=0 then
    begin
      if Rules.ponder then maxtime:=tim1*2
      else maxtime:=((tim+incr*(movs-1))div 3)-500
    end
    else maxtime:=tim1;
    if Rules.ponder then maxtime:=trunc(1.1*maxtime);
    if maxtime<tim1 then maxtime:=tim1;
    if maxtime>tim then maxtime:=tim;
    tim:=tim1;
  end;
  nodes:=0;
  nps:=0;
  is_gg:=false;
  movegen(0);
  j:=0;
  for i:=1 to tree[0].movenum do
  begin
    sortroot[1,i]:=i;
    sortroot[2,i]:=-1000;
    if makemove(moves[i],0) then
    begin
      inc(j);
      sortroot[2,i]:=random(1001);
      unmakemove(moves[i],0);
    end;
  end;
  rootsort;
  HistoryInit;
  tree[0].movenum:=j;
  tree[0].check:=attacked(tree[0].tomove,0,255);
  otmena:=false;
  for i:=1 to maxply do
  begin
    rootsort;
    lin[0]:=0;
    ev:=searchroot(i,0,lin);
    if otmena then
    begin
      if ev<>-inf then bestlin:=lin;
      break;
    end;
    PVToHash(ev,i,lin);
    tim1:=gettimer;
    bestlin:=lin;
    if (abs(ev)+100>inf) and not(rules.ponder) then break;
    if (abs(ev)+100>inf) and (rules.ponder) then is_gg:=true;
    if (rules.depth<>0) and (i>=rules.depth) then break;
    if (i>5) then
    begin
      if (tree[0].movenum=1) and not(rules.ponder) then break;
      if (tim1>tim/2) and (maxtime>0) and (tim<>0) and not(rules.ponder) then break;
    end;
  end;
  s:='bestmove '+koord[bestlin[bestlin[0]] and 255]+koord[(bestlin[bestlin[0]] shr 8) and 255];
  if (bestlin[bestlin[0]] shr 24)<>0 then s:=s+figs[1,bestlin[bestlin[0]] shr 24];
  if ponder then
  begin
    s:=s+' ponder '+koord[bestlin[bestlin[0]-1] and 255]+koord[(bestlin[bestlin[0]-1] shr 8) and 255];
    if (bestlin[bestlin[0]-1] shr 24)<>0 then s:=s+figs[1,bestlin[bestlin[0]-1] shr 24];
  end;
  lprint(s);
  EndThread(0);
end;

function SearchRoot(depth,ply:byte; var lin:tline):integer;
var alpha,tmp,mo,bm:integer;
    newdepth,p1,p2:byte;
    i,j,f,t,z:integer;
    tmplin:tline;
    s:string;
begin
  inc(nodes);
  alpha:=-inf;
  f:=1; t:=tree[ply].movenum;
  j:=0; bm:=0;
  tree[ply].hflag:=1;
  for i:=f to t do
  begin
    mo:=moves[sortroot[1,i]];
    if makemove(mo,ply) then
    begin
      inc(j);
      if nps<>0 then lprint('info depth '+inttostr(depth)+' currmovenumber '+inttostr(j)+' currmove '+koord[mo and 255]+koord[(mo shr 8) and 255]);
      newdepth:=depth-1;
      tree[ply+1].check:=attacked(tree[ply+1].tomove,ply+1,255);
      p1:=(tree[ply].lastmove shr 16) and 255;
      p2:=(tree[ply+1].lastmove shr 16) and 255;
      if (prices[p1]=prices[p2]) and (p1<>0) and (p1<>6) then inc(newdepth);

      if (mo shr 24)<>0 then inc(newdepth);
      if tree[ply+1].check then inc(newdepth);
      tmplin[0]:=0;
      if j=1 then tmp:=-Search(-inf,-alpha,newdepth,ply+1,true,tmplin)
      else
      begin
        tmp:=-Search(-alpha-1,-alpha,newdepth,ply+1,true,tmplin);
        if tmp>alpha then
        begin
          tmplin[0]:=0;
          tmp:=-Search(-inf,-alpha,newdepth,ply+1,true,tmplin);
        end;
      end;
      unmakemove(mo,ply);

      if otmena then
      begin
        result:=alpha;
        exit;
      end;
      sortroot[2,i]:=tmp;
      if tmp>alpha then
      begin
        tree[ply].hflag:=2;
        bm:=mo;
        alpha:=tmp;
        lin:=tmplin;
        inc(lin[0]);
        lin[lin[0]]:=mo;
        s:='info depth '+inttostr(depth)+' nodes '+inttostr(nodes)+' score ';
        if abs(tmp)+100<inf then s:=s+'cp '+inttostr(tmp)
        else
        begin
          if tmp>0 then s:=s+'mate '+inttostr((inf-tmp) div 2)
          else s:=s+'mate -'+inttostr((inf-abs(tmp)) div 2);
        end;

        s:=s+' pv';
        for z:=lin[0] downto 1 do
          s:=s+' '+koord[lin[z] and 255]+koord[(lin[z] shr 8) and 255];
        lprint(s);
      end;
    end else sortroot[2,i]:=-inf;
  end;
  if tree[ply].check then
  begin
    if j=0 then alpha:=-inf+ply+1;
  end else if j=0 then alpha:=0;
  SaveToHash(depth,ply,alpha,bm);
  result:=alpha;
end;

function Search(alpha,beta:integer; depth,ply:byte; null:boolean; var lin:tline):integer;
var oalpha,score,tmp,tmm,mo,bm,futval:integer;
    tim:longint;
    newdepth:integer;
    p1,p2:byte;
    i,j,f,t,st:integer;
    tmplin:tline;
    red:boolean;
label endsearch;
begin
  if depth=0 then
  begin
    result:=QSearch(alpha,beta,ply);
    exit;
  end;
  inc(nodes);
  if (nodes mod 100000)=0 then
  begin
    tim:=gettimer;
    if ((tim>maxtime) and (maxtime>0) and not(rules.ponder)) or (not(rules.ponder) and is_gg) then
    begin
      otmena:=true;
      result:=beta;
      exit;
    end;
    if tim<>0 then
    begin
      nps:=trunc((nodes/tim)*1000);
      lprint('info nodes '+inttostr(nodes)+' nps '+inttostr(nps));
    end;
  end;

  if (null) and (CheckReps(ply)) then
  begin
    result:=0;
    exit;
  end;
  
  LoadFromHash(ply);
  if (tree[ply].hflag<>0) and (tree[ply].hdepth>=depth) and (beta-alpha=1) then
  begin
    if tree[ply].hflag=1 then
    begin
      if tree[ply].hscore<=alpha then
      begin
        result:=tree[ply].hscore;
        exit;
      end;
    end;
    if tree[ply].hflag=2 then
    begin
      result:=tree[ply].hscore;
      exit;
    end;
    if tree[ply].hflag=3 then
    begin
      if tree[ply].hscore>=beta then
      begin
        result:=tree[ply].hscore;
        exit;
      end;
    end;
  end;

  if (null) and not(tree[ply].check) and (beta-alpha=1) and (abs(beta)+100<inf)
      and (depth>1) and ((depth<=4) or (evalution(ply,alpha,beta)>=beta))
      and not(tree[ply].hmate) then
  begin
    copytree(ply,ply+1);
    tree[ply+1].tomove:=1-tree[ply].tomove;
    tree[ply+1].boardkey:=tree[ply+1].boardkey xor ZorbistEnp[tree[ply].enpass];
    tree[ply+1].enpass:=255;
    tree[ply+1].boardkey:=tree[ply+1].boardkey xor ZorbistEnp[255];
    tree[ply+1].boardkey:=tree[ply+1].boardkey xor ZorbistColor;
    tmplin[0]:=0;
    newdepth:=depth-4;
    if newdepth<0 then newdepth:=0;
    tmp:=-Search(-beta,-beta+1,newdepth,ply+1,false,tmplin);
    if tmp>=beta then
    begin
      if (tree[ply].matw<1000) and (tree[ply].matb<1000) and (Depth>5) then
      begin
        tmplin[0]:=0;
        newdepth:=depth-5;
        tmp:=Search(alpha,beta,newdepth,ply,false,tmplin);
        if tmp>=beta then
        begin
          tree[ply].hflag:=3;
          SaveToHash(depth,ply,tmp,tree[ply].hmove);
          result:=tmp;
          exit;
        end;
      end else
      begin
        tree[ply].hflag:=3;
        SaveToHash(depth,ply,tmp,tree[ply].hmove);
        result:=tmp;
        exit;
      end;
    end;
    if tmp<-inf+100 then tree[ply].hmate:=true;
  end;

 if (tree[ply].hmove=0) and (depth>3) and (beta-alpha>1) then
  begin
    tmplin[0]:=0;
    tmp:=Search(alpha,beta,depth-2,ply,null,tmplin);
    if tmp<=alpha then Search(-inf,beta,depth-2,ply,null,tmplin);
    tree[ply].hmove:=tmplin[tmplin[0]];
  end;

  score:=-inf;
  futval:=inf;
  movegen(ply);
//  if tree[ply].check then SortLegal(ply)
//  else SortInit(ply);
//  SortLegal(ply);
  SortInit(ply);
  tree[ply].hflag:=1;
  f:=ply*300+1; t:=ply*300+tree[ply].movenum;
  j:=0; bm:=0; st:=0;
  oalpha:=alpha;
  for i:=f to t do
  begin
    st:=i;
    mo:=moves[sortm[1,i]];
    if (depth<=3) and (beta-oalpha=1) and not(tree[ply].check)
        and ((mo shr 16)=0) and (mo<>killers[ply,1]) and (mo<>killers[ply,2])
        and not(tree[ply].hmate) then
    begin
      if futval=inf then
      begin
        if depth=3 then futval:=cqueen
        else if depth=2 then futval:=cbishop
        else futval:=cpawn;
        inc(futval,evalution(ply,alpha,beta));
      end;
    end;
    if makemove(mo,ply) then
    begin
      inc(j);
      newdepth:=depth-1;
//      if (tree[ply].check) and (tree[ply].movenum=1) then newdepth:=depth;
      if tree[ply].hmate then newdepth:=depth;
      tree[ply+1].check:=attacked(tree[ply+1].tomove,ply+1,255);
      p1:=(tree[ply].lastmove shr 16) and 255;
      p2:=(tree[ply+1].lastmove shr 16) and 255;
      if (prices[p1]=prices[p2]) and (p1<>0) and (p1<>6) then newdepth:=depth;
      if tree[ply+1].check then newdepth:=depth;
      p1:=(tree[ply].lastmove shr 8) and 255;
      if (board[p1]=6+64) and (p1>95) then newdepth:=depth;
      if (board[p1]=6+128) and (p1<24) then newdepth:=depth;
      if (mo shr 24)<>0 then newdepth:=depth;

      if (depth<=3) and (beta-oalpha=1) and not(tree[ply].check) and not(tree[ply+1].check)
          and ((mo shr 16)=0) and (newdepth<depth) and (mo<>killers[ply,1]) and (mo<>killers[ply,2])
          and not(tree[ply].hmate) then
        if (futval<=alpha) then
        begin
          if futval>score then
          begin
            score:=futval;
            lin[0]:=0;
          end;
          unmakemove(mo,ply);
          continue;
        end;

      red:=false;
      tmp:=sortm[2,i];
      if not(tree[ply].check) and not(tree[ply+1].check) and (depth<=4) and (beta-oalpha=1)
          and (newdepth<depth) and ((mo shr 16)=0) and (mo<>killers[ply,1]) and (mo<>killers[ply,2])
          and not(tree[ply].hmate) then
      begin
        if depth<=3 then tmm:=3276
        else tmm:=2457;
        if tmp<tmm then
        begin
          unmakemove(mo,ply);
          continue;
        end;
      end;
      if (depth>=3) and not(tree[ply].check) and not(tree[ply+1].check) and (beta-oalpha=1)
          and (newdepth<depth) and ((mo shr 16)=0) and (mo<>killers[ply,1]) and (mo<>killers[ply,2])
          and (j>=3) and not(tree[ply].hmate) then
      begin
        if tmp<9830 then
        begin
          red:=true;
          dec(newdepth);
          if (depth>=8) and (tmp<4915) then dec(newdepth);
        end;
      end;
      if (newdepth<0) then newdepth:=0;
      
      tmplin[0]:=0;
      if (beta-oalpha=1) or (j=1) then tmp:=-Search(-beta,-alpha,newdepth,ply+1,null,tmplin)
      else
      begin
        tmp:=-Search(-alpha-1,-alpha,newdepth,ply+1,null,tmplin);
        if tmp>alpha then
        begin
          tmplin[0]:=0;
          tmp:=-Search(-beta,-alpha,newdepth,ply+1,null,tmplin);
        end;
      end;
      if (red) and (tmp>alpha) then
      begin
        inc(newdepth);
        tmplin[0]:=0;
        tmp:=-Search(-beta,-alpha,newdepth,ply+1,null,tmplin);
      end;

      unmakemove(mo,ply);
      if otmena then goto endsearch;
      if tmp>score then score:=tmp;
      if tmp>alpha then
      begin
        alpha:=tmp;
        lin:=tmplin;
        inc(lin[0]);
        lin[lin[0]]:=mo;
        bm:=mo;
        tree[ply].hflag:=2;
      end;
      if tmp>=beta then
      begin
        tree[ply].hflag:=3;
        goto endsearch;
      end;
    end;
  end;
  if tree[ply].check then
  begin
    if j=0 then score:=-inf+ply+1;
  end else if j=0 then score:=0;
endsearch:
  if bm<>0 then
  begin
    GoodMove(bm,ply,depth);
    if (score>=beta) and ((bm shr 16)=0) then
    begin
      for i:=f to st-1 do
        HistoryBad(moves[sortm[1,i]]);
      HistoryGood(bm);
    end;
  end;
  SaveToHash(depth,ply,score,bm);
  result:=score;
end;

function QSearch(alpha,beta:integer; ply:byte):integer;
var oalpha,dval,score,tmp,mo:integer;
    tim:longint;
    i,j,f,t:integer;
begin
  inc(nodes);
  if (nodes mod 100000)=0 then
  begin
    tim:=gettimer;
    if ((tim>maxtime) and (maxtime>0) and not(rules.ponder)) or (not(rules.ponder) and is_gg) then
    begin
      otmena:=true;
      result:=beta;
      exit;
    end;
    if tim<>0 then
    begin
      nps:=trunc((nodes/tim)*1000);
      lprint('info nodes '+inttostr(nodes)+' nps '+inttostr(nps));
    end;
  end;
  dval:=inf;
  oalpha:=alpha;
  score:=-inf;
  if not(tree[ply].check) then
  begin
    score:=evalution(ply,alpha,beta);
    if score>alpha then alpha:=score;
    if score>=beta then
    begin
      result:=score;
      exit;
    end;
    dval:=score+50;
    killgen(ply);
  end else movegen(ply);
  tree[ply].hmove:=0;
  SortInit(ply);
  f:=ply*300+1; t:=ply*300+tree[ply].movenum; j:=0;
  for i:=f to t do
  begin
    mo:=moves[sortm[1,i]];
//    if makemove(mo,ply) then
    if makemove_q(mo,ply) then
    begin
      inc(j);
      tree[ply+1].check:=attacked(tree[ply+1].tomove,ply+1,255);
      if ((beta-oalpha)=1) and not(tree[ply+1].check) and not(tree[ply].check) then
      begin
        tmp:=dval+prices[(mo shr 16) and 255];
        if (mo shr 24)<>0 then
          tmp:=tmp-prices[6]+prices[mo shr 24];
        if tmp<=alpha then
        begin
          if tmp>score then score:=tmp;
          unmakemove(mo,ply);
          continue;
        end;
      end;
      tmp:=-Qsearch(-beta,-alpha,ply+1);
      unmakemove(mo,ply);
      if otmena then
      begin
        result:=score;
        exit;
      end;
      if tmp>score then score:=tmp;
      if tmp>alpha then alpha:=tmp;
      if tmp>=beta then
      begin
        result:=tmp;
        exit;
      end; 
    end;
  end;
  if (tree[ply].check) and (j=0) then score:=-inf+ply+1;
  result:=score;
end;

end.
